#include <bits/stdc++.h>

const int maxn = 100;
const int maxvalue = 1024;

int dp[maxvalue][maxn];

int main() {
  int n, x;
  scanf("%d%d", &n, &x);
  std::vector<int> a(n);
  for (int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
  }
  if (n == 1) {
    printf("%d\n", (x % a[0] == 0 ? x / a[0] : -1));
    return 0;
  }
  for (int j = 0; j < maxvalue; j++) {
    for (int i = 0; i < maxn; i++) {
      dp[j][i] = INT_MAX;
    }
  }
  dp[x % maxvalue][0] = 0;
  for (int mj = x; mj > 0; mj--) {
    for (int i = 0; i < n; i++) {
      int j = mj % maxvalue;
      if (dp[j][i] == INT_MAX) {
        continue;
      }
      if (mj >= a[i]) {
        int ni = std::min(n - 1, i + 1);
        int nj = (mj - a[i]) % maxvalue;
        dp[nj][ni] = std::min(dp[nj][ni], dp[j][i] + 1);
      }
      if (mj >= a[0]) {
        int nj = (mj - a[0]) % maxvalue;
        dp[nj][1] = std::min(dp[nj][1], dp[j][i] + 2);
      }
      dp[j][i] = INT_MAX;
    }
  }
  int answer = INT_MAX;
  for (int i = 0; i < n; i++) {
    answer = std::min(answer, dp[0][i]);
  }
  printf("%d\n", answer == INT_MAX ? -1 : answer);
}
