#include <bits/stdc++.h>

int n, s;
std::map<std::pair<int, int>, int> min_moves;

int go(const std::vector<int> &a, int x, int pos) {
  if (x == 0) {
    return 0;
  }
  auto it = min_moves.find({x, pos});
  if (it != min_moves.end()) {
    return it->second;
  }
  int answer = INT_MAX / 2;
  if (x >= a[pos]) {
    int npos = (pos == n - 1 ? n - 1 : pos + 1);
    answer = go(a, x - a[pos], npos) + 1;
  }
  if (x >= a[0]) {
    answer = std::min(answer, go(a, x - a[0], 1) + 2);
  }
  min_moves[{x, pos}] = answer;
  return answer;
}

int main() {
  scanf("%d%d", &n, &s);
  std::vector<int> a(n);
  for (int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
  }
  if (n == 1) {
    printf("%d\n", (s % a[0] == 0 ? s / a[0] : -1));
    return 0;
  }
  int answer = go(a, s, 0);
  printf("%d\n", answer >= INT_MAX / 2 ? -1 : answer);
}
