#include <bits/stdc++.h>

using namespace std;

const int MOD = 1000 * 1000 * 1000 + 7;
const int MAXN = 3007;

long long fact[MAXN], rfact[MAXN];

long long binPow(long long x, long long y)
{
	if (y == 0) return 1;
	if (y % 2 == 0)
	{
		long long t = binPow(x, y / 2);
		return (t * t) % MOD;
	}
	else
	{
		return (binPow(x, y - 1) * x) % MOD;
	}
}
long long inv(long long x)
{
	return binPow(x, MOD - 2);
}
long long cnk(int n, int k)
{
	long long res = fact[n];
	res = (res * rfact[k]) % MOD;
	res = (res * rfact[n - k]) % MOD;
	return res;
}
int cnt[MAXN];
long long dp[MAXN][MAXN];
int main()
{
    //freopen("socks.in", "r", stdin);
    //freopen("socks.out", "w", stdout);
	int n;
	scanf("%d", &n);
	fact[0] = 1;
	for (int i = 1; i <= n; i++)
	{
		fact[i] = (fact[i - 1] * i) % MOD;
		int x;
		scanf("%d", &x);
		cnt[x]++;
	}
	for (int i = n; i >= 0; i--)
	{
		rfact[i] = inv(fact[i]);
	}
	dp[0][0] = 1;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j <= n; j++)
		{
			for (int k = 0; j + k <= n && k <= cnt[i + 1]; k++)
			{
				long long go = dp[i][j];
				go = (go * cnk(cnt[i + 1], k)) % MOD;
				go = (go * cnk(cnt[i + 1], k)) % MOD;
                go = (go * fact[k]) % MOD;
			//	go = (go * rfact[cnt[i + 1] - k]) % MOD;
				dp[i + 1][j + k] = (dp[i + 1][j + k] + go) % MOD;
			}
		}
	}
	long long res = 0;
	for (int i = 0; i <= n; i++)
	{
		long long go = dp[n][i];
		go = (go * fact[n - i]) % MOD;
		if (i % 2 == 1)
		{
			go = (MOD - go) % MOD;
		}
		res = (res + go) % MOD;
	}
	printf("%lld\n", res);
}

