#include "testlib.h"

#include <set>
#include <cstring>

const int maxN = 100000;

int main(int argc, char* argv[]){
    registerValidation(argc, argv);
    int n = inf.readInt(3, maxN, "n");
    inf.readEoln();
    std::set<int> s;
    for(int i = 0; i < n; i++){
        int x = inf.readInt(1, n, "Incorrect a[" + std::to_string(i + 1) + "]");
        if(i < n - 1){
            inf.readSpace();
        }
        s.insert(x);
    }
    ensuref((int)s.size() == n, "songs are not distinct");
    inf.readEoln();
    inf.readEof();
}