#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
 
const int N = 500 + 7;
 
char c[N][N], res[N][N];
int l[N], r[N];
char ans[N][N];
int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};
int n, m;
 
bool good(int x, int y)
{
    return (x >= 0 && x < n && y >= 0 && y < m);
}
 
bool kok(int x, int y)
{
    if (c[x][y] == '.' || res[x][y] == '*') return false;
    int bl = 0;
    int kok = 0;
    int rg = 0;
    for (int ax = -1; ax <= 1; ax++)
    {
        for (int ay = -1; ay <= 1; ay++)
        {
            if (ax == 0 && ay == 0)
            {
                continue;
            }
            if (good(x + ax, y + ay) && c[x + ax][y + ay] == '*')
            {
                kok++;
            }
            if (ax != 0 && ay != 0)
            {
                int cnt = 0;
                if (good(x + ax, y + ay) && c[x + ax][y + ay] == '*')
                {
                    cnt++;
                }
                if (good(x + ax, y) && c[x + ax][y] == '*')
                {
                    cnt++;
                }
                if (good(x, y + ay) && c[x][y + ay] == '*')
                {
                    cnt++;
                }
                if (cnt == 3)
                {
                    bl++;
                }
            }
            else
            {
                if (good(x + ax, y + ay) && c[x + ax][y + ay] == '*')
                {
                    rg++;
                }
            }
        }
    }
    return (bl == 1 && rg == 2) || (kok == 1);
}
 
int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    //ifstream cin("a.in");
    //ofstream cout("a.out");
    #else
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    #endif // ONPC
    cin >> n >> m;
    int first = -1, last = -1;
    int x = m, y = 0;
    for (int i = 0; i < n; i++)
    {
        l[i] = -1, r[i] = -1;
        for (int j = 0; j < m; j++)
        {
            cin >> c[i][j];
            res[i][j] = c[i][j];
            if (c[i][j] == '*')
            {
                if (l[i] == -1)
                {
                    l[i] = j;
                }
                r[i] = j;
                if (first == -1)
                {
                    first = i;
                }
                last = i;
            }
        }
        if (l[i] != -1)
        {
            x = min(x, l[i]);
            y = max(y, r[i]);
        }
    }
    if (first == -1)
    {
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                cout << '.';
            }
            cout << '\n';
        }
        return 0;
    }
    queue <pair <int, int> > q;
    for (int i = first; i <= last; i++)
    {
        for (int j = x; j <= y; j++)
        {
            c[i][j] = '*';
            q.push({i, j});
        }
    }
    while (!q.empty())
    {
        int x = q.front().first, y = q.front().second;
        q.pop();
        if (!kok(x, y))
        {
            continue;
        }
        c[x][y] = '.';
        for (int ax = -1; ax <= 1; ax++)
        {
            for (int ay = -1; ay <= 1; ay++)
            {
                if (x + ax >= 0 && x + ax < n && y + ay >= 0 && y + ay < m)
                {
                    q.push({x + ax, y + ay});
                }
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            cout << c[i][j];
        }
        cout << '\n';
    }
}