#include "testlib.h"
#include <iostream>
using namespace std;

const int N = 100005;
int sizes[N];
vector<int> perm_small;
vector<int> perm_big;
vector <string> strs;

void gen(int n, int len, int cnt) {
    cout << n << endl;
    int max_add = len / (2 * n);
    int rem = len;
    for (int i = 0; i < 2 * n; i++) {
    	sizes[i] = 1;
    	rem -= sizes[i];
    }
    for (int i = 0; i < rem; ++i) {
    	sizes[rnd.next(0, 2 * n - 1)]++;
    }
    sort(sizes, sizes + 2 * n);
    for (int i = 0; i < n; i++) {
    	perm_small.push_back(i);
    	perm_big.push_back(i + n);
    } 
    shuffle(perm_small.begin(), perm_small.end());
    shuffle(perm_big.begin(), perm_big.end());
    for (int i = 0; i < n; i++) {
    	string str = "";
    	for (int j = 0; j < sizes[perm_small[i]]; j++) {
    		char lett = 'a' + rnd.next(0, cnt - 1);
    		str += lett;
    	}
    	string str_copy = str;
    	for (int j = sizes[perm_small[i]]; j < sizes[perm_big[i]]; j++) {
    		char lett = 'a' + rnd.next(0, cnt - 1);
    		str_copy += lett;
    	}
    	strs.push_back(str);
    	strs.push_back(str_copy);
    }
    shuffle(strs.begin(), strs.end());
    for (int i = 0; i < (int)strs.size(); i++) {
    	cout << strs[i] << endl;
    }
}

int main(int argc, char * argv[]) {
    registerGen(argc, argv, 1);
    // len >= 2 * n
    int n = atoi(argv[1]);
    int len = atoi(argv[2]);
    // count of different letters
    int cnt = atoi(argv[3]);
    gen(n, len, cnt);
    return 0;
}