#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 1e6 + 5;

int in[MAXN], out[MAXN];
int sz[MAXN];
int t;
vector<int> graph[MAXN];
vector<int> order;

int dfs(int v, int p) {
    order.puba(v);
    sz[v] = 1;
    in[v] = t++;
    for (int to : graph[v]) {
        if (to != p) {
            dfs(to, v);
            sz[v] += sz[to];
        }
    }
    out[v] = t;
    return 0;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 4);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int q = atoi(argv[3]);

    cout << n << "\n";

    vector<int> nodes_order;
    for (int i = 0; i < n; ++i) {
        nodes_order.puba(i);
    }
    shuffle(nodes_order.begin() + 1, nodes_order.end());

    vector<pii> edges;
    for (int i = 0; i < n - 1; ++i) {
        int a = nodes_order[i + 1];
        int b = nodes_order[rnd.next(0, i)];
        if (rnd.next(0, 1)) {
            swap(a, b);
        }
        graph[a].puba(b);
        graph[b].puba(a);
        edges.puba({a, b});
    }

    shuffle(bend(edges));

    for (pii e : edges) {
        cout << e.ff + 1 << " " << e.ss + 1 << "\n";
    }

    dfs(0, 0);

    vector<ll> pref = {0};
    for (int i = 0; i < n; ++i) {
        pref.puba(pref.back() + sz[i] - 1);
    }

    cout << m << "\n";
    for (int i = 0; i < m; ++i) {
        ll pos = rnd.next(1ll, pref.back());
        int v = lower_bound(bend(pref), pos) - pref.begin() - 1;
        int u = order[in[v] + pos - pref[v]];
        cout << u + 1 << " " << v + 1 << "\n";
    }

    cout << q << "\n";

    for (int i = 0; i < q; ++i) {
        int v = rnd.next(0, n - 1);
        int k = rnd.next(0, m);
        cout << v + 1 << " " << k << "\n";
    }

    return 0;
}